// Analog Counter
/*==================================================================================================================*/
function ACanimate(params)
{
	var start = new Date; //время начала 

	var timer = setInterval(
		function() 
		{
			//узнаем сколько прошло времени
			var progress = (new Date - start) / params.duration;
			if(progress > 1) progress = 1;
			params.step(progress);	//отрисовать анимацию
			if(progress == 1) 
			{
			clearInterval(timer);	//конец
			params.oncomplete();	
			}
		}
		,params.delay || 10		);	
}

function ACfindByVal(array,val)
{
var result = -1;
	for(var i = 0; i <= array.length; i++)
	{
	
		if(array[i] == val)
		{
			result = i;
		}
	}

return result;
}	
/*==================================================================================================================*/
function ACFrame(id,parent,framestyle)
{
var _this = this;
this.div = document.createElement('div');// создаем контейнер для фрейма
this.states = {0: 0, 1: 0-framestyle.height, 2: framestyle.height}; // массив со состояниями
this.state = null; // текущее состояние
this.inprogress = false; // идет ли анимация в данный момент?
this.curvalue = null; //значение(число) фрейма
	
	this.SetValue = function(val)// устанавливает значение фрейма
	{
		this.div.innerHTML = val;
		this.curvalue = val;
	}
	
	this.SetPosTop = function(pos)
	{
		this.div.style.top = pos + 'px';
	}

	this.SetState = function(statenum)//установка состояния без анимации
	{
		if(!this.inprogress)//если не в процессе
		{
		switch(statenum)
		{
			case 0:
				this.state = statenum;
				this.SetPosTop(this.states[0]);
			break;
			case 1:
				this.state = statenum;
				this.SetPosTop(this.states[1]);
			break;
			case 2:
				this.state = statenum;
				this.SetPosTop(this.states[2]);
			break;
		}
		}
	}
	
	this.GetState = function()
	{
		return this.state;
	}
	
	this.Animate = function(oncomplete,dur) // шаг-переход с анимацией в следущее состояние из текущего
	{
		if(!this.inprogress)// проверка 
		{
		switch(this.state)
		{
			case 0:
				this.inprogress = true;
				ACanimate(
				{
				duration: dur || 1000, // отведенное время для анимации
				step: function(progress){
									_this.SetPosTop(progress * -framestyle.height); // анимируем до состояния 1
								},
				oncomplete: function(){ 
									_this.inprogress = false;
									_this.SetState(2);	// сразу переходим в состояние 2 т.к из 1 в 2 нечего анимировать.
									oncomplete();
								}								
				});	
			break;
			case 2:
				this.inprogress = true;
				ACanimate(
				{
				duration: dur || 1000, // отведенное время для анимации
				step: function(progress){
									_this.SetPosTop((progress * -framestyle.height) + parseInt(framestyle.height,10)); // анимируем до состояния 0 
								},
				oncomplete: function(){ 
									_this.inprogress = false;
									_this.SetState(0); // переходим в состояние 0
									oncomplete();
								}
				});	
			break;
		}
		}
	}
	
	this.Construct = function()
	{
		this.div.id = 'ccounter_frame' + id;
		this.div.setAttribute('align','center');
		this.div.align = 'center';
		this.div.style.width = framestyle.width + 'px';
		this.div.style.height = framestyle.height + 'px';
		this.div.style.position = 'absolute';
		this.div.style.textAlign = 'center';
		this.div.style.fontSize = framestyle.fontSize || ((framestyle.height / 100) * 87)*1 +'px';
		this.div.style.fontWeight = framestyle.fontWeight || 'Bold';
		this.div.style.lineHeight = framestyle.height + 'px';
		this.div.style.color = framestyle.color;
		
				//this.div.style.border = framestyle.border || 'none';
				this.div.style.borderTop = framestyle.border || 'none';
				this.div.style.borderBottom = framestyle.border || 'none';
				this.div.style.borderColor = framestyle.borderColor || 'gray';
				this.div.style.borderWidth = '1px';
				
		parent.appendChild(this.div); //добавляем фрейм в родителя
	}
this.Construct();
}
/*==================================================================================================================*/
function ACGear(id,parent,style,startVal)
{
var _this = this;
this.div_cont = document.createElement('div');// контейнер для колеса
this.frame1 = new ACFrame(id + '_f1',this.div_cont,style);// контейнер 1 части колеса
this.frame2 = new ACFrame(id + '_f2',this.div_cont,style);// контейнер 2 части колеса
this.inprogress = false; // идет ли анимация в данный момент?
this.p_counter = 0; //счетчик шага, =2 когда прошли 2 анимации фреймов
this.curvalue = 0; //текущее значение колеса
this.targetvalue = 0; //целевое значение при анимации
this.content_array = ['0','1','2','3','4','5','6','7','8','9'];//контент колеса, любое кол-во любых символов
	
 
	this.SetStartValue = function(val)
	{
		//устанавливаем значение при инициализации
		this.curvalue = ACfindByVal(this.content_array,val);
		this.targetvalue = ACfindByVal(this.content_array,val);
		this.Step(50);// не использовал функцию анимации т.к в ней защита от повтора и оно не срабатывает
	}
	
	this.CompleteStep = function(dur)
	{
		this.p_counter++;
		if(this.p_counter == 2) //если 2 фрейма закончили анимацию
		{
			this.p_counter = 0; //ставим счетчик анимации фреймов в 0
			if(this.curvalue != this.targetvalue) //если не достигнуто целевое знач. то анимируем
			{
				this.Step(dur);
			}
			else
			{
				this.inprogress = false;  //если достигнуто целевое то отключаем прогресс
			}
		}
	}
	
	this.Step = function(dur)
	{
	this.inprogress = true; //включаем прогресс
	if(this.curvalue == this.content_array.length-1) this.curvalue = -1; //если 9 (максимум) то ставим на -1
	this.curvalue++; // прибавляем текущее значение
	
		//если фрейм находится в позиции 2 (скрытой) то меняем ему значение на текущее
		if(this.frame1.GetState() == 2) 
		{
			this.frame1.SetValue(this.content_array[this.curvalue]);
		}
		if(this.frame2.GetState() == 2) 
		{
			this.frame2.SetValue(this.content_array[this.curvalue]);
		}
		
	this.frame1.Animate(function(){_this.CompleteStep(dur);},dur);
	this.frame2.Animate(function(){_this.CompleteStep(dur);},dur);									
	}
		
	this.SetValueAnim = function(val,dur)
	{
		if(!this.inprogress)//проверка на прогресс
		{
			this.targetvalue = ACfindByVal(this.content_array,val); //установка целевого значения
			if(this.curvalue != this.targetvalue) // не анимируем если целевое значение = текущее значение
			{
				this.Step(dur || 700);
			}
		}
	}
		
	this.Counstruct = function()
	{
		// контейнер для колеса
		this.div_cont.id = 'ccounter_cont' + id;
		this.div_cont.style.width = style.width + 'px';
		this.div_cont.style.height = style.height + 'px'; 
		this.div_cont.style.overflow = 'hidden';
		this.div_cont.style.backgroundColor = '#666';
		this.div_cont.style.backgroundImage = style.backgroundImage;
		this.div_cont.style.backgroundRepeat = 'no-repeat';
		this.div_cont.style.backgroundSize = 'cover';
		this.div_cont.style.position = 'relative';
		
				//this.div_cont.style.border = 'solid';
				//this.div_cont.style.borderColor = 'yellow';
		
		
		//добавляем на страницу
		parent.appendChild(this.div_cont);
		
		//устанавливаем начальные положения
		this.frame1.SetState(0);
		this.frame2.SetState(2);
		
		//устанавливаем индикатор в 0
		this.SetStartValue(startVal);
	}
this.Counstruct();
}
/*==================================================================================================================*/
function ACMain(id,parent,style,numof_gears,startVal)
{
this.table_cont = document.createElement('table');
this.gears = []; //массив шестерней
this.curvalue = null;

	this.SetValue = function(val,dur)
	{
		this.curvalue = val;
		this.j = 0;//для выборки символов из массива
		for(var i = 0; i < numof_gears; i++)//отсчитываем номер колеса с конца в зависимости от длинны значения и начинаем цикл оттуда
		{
			if(i >= numof_gears - val.toString().length)
			{
				this.gears[i].SetValueAnim(val.toString().charAt(this.j),dur); //устанавливаем значение колеса
				this.j++;
			}
			else
			{
				this.gears[i].SetValueAnim(0,dur);
			}
			
		}
	}
	
	this.Create = function()
	{
		//настраиваем таблицу в которой будет счетчик
		this.table_cont.id = 'ccounter_table' + id;
		this.table_cont.style.height = style.height + 'px';
		this.table_cont.style.width = style.width * numof_gears + 'px';
		this.table_cont.setAttribute('border',0);
		this.table_cont.setAttribute('cellspacing',0);
		this.table_cont.setAttribute('cellpadding',0);
		this.table_cont.cellPadding = '0';
		this.table_cont.cellSpacing = '0';
		
		//создаем колонку и строку
		this.tbody = document.createElement('tbody');
		this.tr = document.createElement('tr');
		this.tbody.appendChild(this.tr);
		
		//добавляем TD"шки и вставляем туда шестерни 
		for(var i = 1; i <= numof_gears; i++)
		{
			this.td = document.createElement('td');
			this.td.id =  'ccounter_table' + id + '_td' + i;
			this.tr.appendChild(this.td);
			
			this.gears[i-1] = new ACGear(id+'_'+i,this.td,style,'0');
			
		}
		//добавляем это все добро на страницу	
		this.table_cont.appendChild(this.tbody);
	}
	
	this.Construct = function()
	{

		this.Create();
		parent.appendChild(this.table_cont);
		
		//this.SetValue(startVal,100);
	}
this.Construct();
}
/*==================================================================================================================*/
